<?php
/**
 * AccessLevel Plugin
 * 
 * @author Vasilij BuPy7 Belosludcev
 */ 

defined('_JEXEC') or die;

class plgContentAccesslevel extends JPlugin
{

    protected $autoloadLanguage = true;
    
    public function replaceBetweenTags($string, $tagOpen, $tagClose) 
    {
        $flag = true;
        while ($flag) 
        {
            $beg = stripos($string, $tagOpen);
            $end = stripos($string, $tagClose);

            $flag = false;

            if ($end) 
            {
                $flag = true;
                $string = substr_replace($string, '', $beg, $end - $beg + strlen($tagClose));
            }  
        }
        
        return $string;
    }
    
    public function deleteTags($string, $tagOpen, $tagClose)
    {
        $pattern = array(
                $tagOpen,
                $tagClose
        );
        
        return str_replace($pattern, '', $string);
    }

    public function onContentPrepare($context, &$article, &$params, $limitstart = 0)
    {
        $access = $this->params->get('access');
        
        $user = JFactory::getUser();
        $levels = $user->getAuthorisedViewLevels();

        $alDenFl = false;
        foreach ($levels as $val)
        {
            if ($access == $val)
            {
                $alDenFl = true;
                break;
            }
        }

        if ($alDenFl)
        {      
            $article->text = $this->deleteTags($article->text, '{accesslevel}', '{/accesslevel}');
            $article->text = $this->replaceBetweenTags($article->text, '{accesslevel-guest}', '{/accesslevel-guest}');
        }
        else
        {
            $article->text = $this->replaceBetweenTags($article->text, '{accesslevel}', '{/accesslevel}');
            $article->text = $this->deleteTags($article->text, '{accesslevel-guest}', '{/accesslevel-guest}');
        }

        return true;
    }

}
